searchNodes=[{"doc":"This is a module for launching an SMPPEX.Session implementation as an ESME.To start an ESME one generally should do the following.Implement an SMPPEX.Session behaviour. defmodule MyESMESession do use SMPPEX.Session # ...Callback implementation end Launch it. {:ok, esme_session} = SMPPEX.ESME.start_link(&quot;127.0.0.1&quot;, 2775, {MyESMESession, some_args})","ref":"SMPPEX.ESME.html","title":"SMPPEX.ESME","type":"module"},{"doc":"Starts an SMPPEX.Session implementation as an ESME entitiy, i.e. makes a transport connection to host:port and starts an SMPPEX.Session to handle the connection with the passed module.The function does not return until ESME successfully connects to the specified host and port and initializes or fails. module is the callback module which should implement SMPPEX.ESME behaviour. args is the argument passed to the init callback. opts is a keyword list of different options::transport is Ranch transport used for TCP connection: either :ranch_tcp (the default) or :ranch_ssl;:session_module is a module to use as an alternative to SMPPEX.Session for handling sessions (if needed). For example, SMPPEX.TelemetrySession.:timeout is timeout for transport connect. The default is 5000 ms;:esme_opts is a keyword list of ESME options::timer_resolution is interval of internal ticks on which time related events happen, like checking timeouts for pdus, checking SMPP timers, etc. The default is 100 ms;:enquire_link_limit is value for enquire_link SMPP timer, i.e. the interval of SMPP session inactivity after which enquire_link PDU is send to &quot;ping&quot; the connetion. The default value is 30000 ms;:enquire_link_resp_limit is the maximum time for which ESME waits for enquire_link PDU response. If the response is not received within this interval of time and no activity from the peer occurs, the session is then considered dead and the ESME stops. The default value is 30000 ms;:inactivity_limit is the maximum time for which the peer is allowed not to send PDUs (which are not response PDUs). If no such PDUs are received within this interval of time, ESME stops. The default is :infinity ms;:response_limit is the maximum time to wait for a response for a previously sent PDU. If the response is not received within this interval, handle_resp_timeout callback is triggered for the original pdu. If the response is received later, it is discarded. The default value is 60000 ms.:session_init_limit is the maximum time for the session to be unbound. If no bind request succeed within this interval of time, the session stops. The default value is 10000 ms;:socket_opts is a keyword list of ranch socket options, see ranch's options for more information If :esme_opts list of options is ommited, all options take their default values. The whole opts argument may also be ommited in order to start ESME with the defaults. The returned value is either {:ok, pid} or {:error, reason}.","ref":"SMPPEX.ESME.html#start_link/4","title":"SMPPEX.ESME.start_link/4","type":"function"},{"doc":"SMPPEX.ESME.Sync is an ESME implementation of SMPPEX.Session. It allows to send PDUs to SMSCs in a syncronous way, i.e. blocking till the response PDU comes.One can use with SMPPEX.ESME.Sync all methods provided by SMPPEX.Session like SMPPEX.Session.send_pdu/2, etc.","ref":"SMPPEX.ESME.Sync.html","title":"SMPPEX.ESME.Sync","type":"module"},{"doc":"A nonblocking version of wait_for_pdus/2.The difference is that it always immediately returns a list of items(maybe empty) and never returns :timeout or :stop.","ref":"SMPPEX.ESME.Sync.html#pdus/2","title":"SMPPEX.ESME.Sync.pdus/2","type":"function"},{"doc":"Syncronously sends a PDU and wait for at most timeout ms for a response PDU.The default timeout is 5000 ms.The result value is one of:{:ok, resp}, where resp is a successfully received response PDU;:timeout if the response PDU was not received within timeout;:stop if the ESME stopped while a response was awaited;{:error, reason} if the request failed.","ref":"SMPPEX.ESME.Sync.html#request/3","title":"SMPPEX.ESME.Sync.request/3","type":"function"},{"doc":"Starts SMPPEX.ESME.Sync.opts is a keyword list of SMPPEX.ESME options which is directly passed to the underlying SMPPEX.ESME.start_link/4 call.","ref":"SMPPEX.ESME.Sync.html#start_link/3","title":"SMPPEX.ESME.Sync.start_link/3","type":"function"},{"doc":"Stops ESME.","ref":"SMPPEX.ESME.Sync.html#stop/1","title":"SMPPEX.ESME.Sync.stop/1","type":"function"},{"doc":"Syncronously wait for incoming PDUs. If the ESME already have some received PDUs, they are returned immediately.The default timeout is 5000 ms.The result value is :timeout, :stop or a list of the following items:{:pdu, pdu}, where pdu is an incoming PDU;{:resp, resp_pdu, original_pdu} where resp_pdu is an incoming reply for a previously sent original_pdu;{:timeout, pdu} for pdu's which have not received a response within ESME timeout;{:error, pdu, reason} for outcoming PDUs which were not successfully sent due to reason;{:ok, pdu} for outcoming PDUs which were successfully sent.:timeout returned value indicates that the ESME didn't receive any PDUs within timeout. :stop value indicates that the ESME stopped while waiting for incoming PDUs.","ref":"SMPPEX.ESME.Sync.html#wait_for_pdus/2","title":"SMPPEX.ESME.Sync.wait_for_pdus/2","type":"function"},{"doc":"","ref":"SMPPEX.ESME.Sync.html#t:awaited/0","title":"SMPPEX.ESME.Sync.awaited/0","type":"type"},{"doc":"This is a module for launching a TCP listener (or any other listener supported by ranch, for example, ssl) which handles incoming connections with the passed SMPPEX.Session implementations.To start an MC one generally should do the following.Implement an SMPPEX.Session behaviour. defmodule MyMCSession do use SMPPEX.Session # ...Callback implementation end Start a listener passing implemented behaviour as a callback module. {:ok, listener} = SMPPEX.MC.start({MyESMESession, some_args}, transport_opts: [port: 2775])The important things to note are:There is no start_link method, since started listener is not a standalone GenServer but a pool of socket acceptors running under Ranch supervisor.Each received connection is served with its own process which uses passed callback module (MyESMESession) for handling connection events. Each process has his own state initialized by init callback receiving socket, transport and a copy of arguments (some_args).","ref":"SMPPEX.MC.html","title":"SMPPEX.MC","type":"module"},{"doc":"Starts listener for MC entitiy.module is the callback module which should implement SMPPEX.Session behaviour. args is the argument passed to the init callback each time a new connection is received. opts is a keyword list of different options::transport is Ranch transport used for TCP connections: either ranch_tcp (the default) or ranch_ssl;:transport_opts is a map of Ranch transport options. The major key is socket_opts which contains a list of important options such as {:port, port}. The port is set to 0 by default, which means that the listener will accept connections on a random free port. For backward compatibility one can pass a list of socket options instead of transport_opts map (as in Ranch 1.x).:session_module is a module to use as an alternative to SMPPEX.Session for handling sessions (if needed). For example, SMPPEX.TelemetrySession.:acceptor_count is the number of Ranch listener acceptors, 50 by default.:mc_opts is a keyword list of MC options::timer_resolution is interval of internal ticks on which time related events happen, like checking timeouts for pdus, checking SMPP timers, etc. The default is 100 ms;:session_init_limit is the maximum time for which a session waits an incoming bind request. If no bind request is received within this interval of time, the session stops. The default value is 10000 ms;:enquire_link_limit is value for enquire_link SMPP timer, i.e. the interval of SMPP session inactivity after which enquire_link PDU is send to &quot;ping&quot; the connetion. The default value is 30000 ms;:enquire_link_resp_limit is the maximum time for which a session waits for enquire_link PDU response. If the response is not received within this interval of time and no activity from the peer occurs, the session is then considered dead and the session stops. The default value is 30000 ms;:inactivity_limit is the maximum time for which a peer is allowed not to send PDUs (which are not response PDUs). If no such PDUs are received within this interval of time, the session stops. The default is :infinity ms;:response_limit is the maximum time to wait for a response for a previously sent PDU. If the response is not received within this interval, handle_resp_timeout callback is triggered for the original pdu. If the response is received later, it is discarded. The default value is 60000 ms.:default_call_timeout is an integer greater than zero which specifies how many milliseconds to wait for a reply, or the atom :infinity to wait indefinitely.If no reply is received within the specified time, the function call fails and the caller exits. The default value is 5000 ms. If :mc_opts list of options is ommited, all options take their default values. The returned value is either {:ok, ref} or {:error, reason}. The ref can be later used to stop the whole MC listener and all sessions received by it.","ref":"SMPPEX.MC.html#start/2","title":"SMPPEX.MC.start/2","type":"function"},{"doc":"Stops MC listener and all its sessions.","ref":"SMPPEX.MC.html#stop/1","title":"SMPPEX.MC.stop/1","type":"function"},{"doc":"Module for working with Pdu struct representing parsed SMPP PDU","ref":"SMPPEX.Pdu.html","title":"SMPPEX.Pdu","type":"module"},{"doc":"Makes pdu be reply to the reply_to_pdu, i.e. assigns reply_to_pdu's sequence_number to pdu.Examplesiex(1)&gt; pdu1 = SMPPEX.Pdu.new({0x00000004, 0, 123}) iex(2)&gt; pdu2 = SMPPEX.Pdu.new(0x80000004) |&gt; SMPPEX.Pdu.as_reply_to(pdu1) iex(3)&gt; SMPPEX.Pdu.sequence_number(pdu2) 123","ref":"SMPPEX.Pdu.html#as_reply_to/2","title":"SMPPEX.Pdu.as_reply_to/2","type":"function"},{"doc":"Checks if Pdu is a bind request.Examplesiex(1)&gt; pdu = SMPPEX.Pdu.new(4) iex(2)&gt; SMPPEX.Pdu.bind?(pdu) false iex(3)&gt; pdu = SMPPEX.Pdu.new(1) iex(4)&gt; SMPPEX.Pdu.bind?(pdu) true","ref":"SMPPEX.Pdu.html#bind?/1","title":"SMPPEX.Pdu.bind?/1","type":"function"},{"doc":"Checks if Pdu is a bind response.Examplesiex(1)&gt; pdu = SMPPEX.Pdu.new(0x80000004) iex(2)&gt; SMPPEX.Pdu.bind_resp?(pdu) false iex(3)&gt; pdu = SMPPEX.Pdu.new(0x80000001) iex(4)&gt; SMPPEX.Pdu.bind_resp?(pdu) true","ref":"SMPPEX.Pdu.html#bind_resp?/1","title":"SMPPEX.Pdu.bind_resp?/1","type":"function"},{"doc":"Returns Pdu's command_id.Examplesiex(1)&gt; pdu = SMPPEX.Pdu.new(1) iex(2)&gt; SMPPEX.Pdu.command_id(pdu) 1","ref":"SMPPEX.Pdu.html#command_id/1","title":"SMPPEX.Pdu.command_id/1","type":"function"},{"doc":"Returns Pdu's symbolic command name as an atom or :unknown if Pdu's command_id do not correspond to any real SMPP command.Examplesiex(1)&gt; pdu = SMPPEX.Pdu.new(1) iex(2)&gt; SMPPEX.Pdu.command_name(pdu) :bind_receiver iex(3)&gt; pdu = SMPPEX.Pdu.new(1111111) iex(4)&gt; SMPPEX.Pdu.command_name(pdu) :unknown","ref":"SMPPEX.Pdu.html#command_name/1","title":"SMPPEX.Pdu.command_name/1","type":"function"},{"doc":"Returns Pdu's command_status.Examplesiex(1)&gt; pdu = SMPPEX.Pdu.new({1, 4, 123}) iex(2)&gt; SMPPEX.Pdu.command_status(pdu) 4","ref":"SMPPEX.Pdu.html#command_status/1","title":"SMPPEX.Pdu.command_status/1","type":"function"},{"doc":"Returns Pdu's :destination_addr, :dest_addr_ton and :dest_addr_npi fields in a tuple.Examplesiex(1)&gt; pdu = SMPPEX.Pdu.new(4, %{destination_addr: &quot;to&quot;, dest_addr_ton: 1, dest_addr_npi: 2}) iex(2)&gt; SMPPEX.Pdu.dest(pdu) {&quot;to&quot;, 1, 2}","ref":"SMPPEX.Pdu.html#dest/1","title":"SMPPEX.Pdu.dest/1","type":"function"},{"doc":"Get Pdu mandatory or optional(TLV) field by name or by integer id. If Pdu does not have the field or field name is unknown, nil is returned.Examplesiex(1)&gt; pdu = SMPPEX.Pdu.new(4, %{short_message: &quot;hi&quot;}, %{0x0424 =&gt; &quot;hello&quot;}) iex(2)&gt; SMPPEX.Pdu.field(pdu, :message_payload) &quot;hello&quot; iex(3)&gt; SMPPEX.Pdu.field(pdu, 0x0424) &quot;hello&quot; iex(4)&gt; SMPPEX.Pdu.field(pdu, :short_message) &quot;hi&quot; iex(5)&gt; SMPPEX.Pdu.field(pdu, :unknown_name) nil","ref":"SMPPEX.Pdu.html#field/2","title":"SMPPEX.Pdu.field/2","type":"function"},{"doc":"Get Pdu mandatory field. If Pdu does not have the field, nil is returned.Examplesiex(1)&gt; pdu = SMPPEX.Pdu.new({1, 4, 123}, %{system_id: &quot;system_id&quot;}) iex(2)&gt; SMPPEX.Pdu.mandatory_field(pdu, :system_id) &quot;system_id&quot; iex(3)&gt; SMPPEX.Pdu.mandatory_field(pdu, :short_message) nil","ref":"SMPPEX.Pdu.html#mandatory_field/2","title":"SMPPEX.Pdu.mandatory_field/2","type":"function"},{"doc":"Get the whole set of mandatory fields as a map.Examplesiex(1)&gt; pdu = SMPPEX.Pdu.new(4, %{short_message: &quot;hi&quot;}, %{0x0424 =&gt; &quot;hello&quot;}) iex(2)&gt; SMPPEX.Pdu.mandatory_fields(pdu) %{short_message: &quot;hi&quot;}","ref":"SMPPEX.Pdu.html#mandatory_fields/1","title":"SMPPEX.Pdu.mandatory_fields/1","type":"function"},{"doc":"Construct a new Pdu from header, mandatory fields and optional(TLV) fields.Header may be either an integer, then it is treated as command id, or a tuple {command_id, command_status, sequence_number}Each Pdu is created with a unique ref field, by which one can later trace Pdu's identity.Examplesiex(1)&gt; SMPPEX.Pdu.new(1) %SMPPEX.Pdu{command_id: 1, command_status: 0, mandatory: %{}, optional: %{}, ref: #Reference&lt;0.0.3.215&gt;, sequence_number: 0} iex(2)&gt; SMPPEX.Pdu.new({1, 0, 123}, %{system_id: &quot;sid&quot;, password: &quot;pass&quot;}, %{}) %SMPPEX.Pdu{command_id: 1, command_status: 0, mandatory: %{password: &quot;pass&quot;, system_id: &quot;sid&quot;}, optional: %{}, ref: #Reference&lt;0.0.3.219&gt;, sequence_number: 123}","ref":"SMPPEX.Pdu.html#new/3","title":"SMPPEX.Pdu.new/3","type":"function"},{"doc":"Get Pdu optional(TLV) field by name or by integer id. If Pdu does not have the field or field name is unknown, nil is returned.Examplesiex(1)&gt; pdu = SMPPEX.Pdu.new(4, %{}, %{0x0424 =&gt; &quot;hello&quot;}) iex(2)&gt; SMPPEX.Pdu.optional_field(pdu, :message_payload) &quot;hello&quot; iex(3)&gt; SMPPEX.Pdu.optional_field(pdu, 0x0424) &quot;hello&quot; iex(4)&gt; SMPPEX.Pdu.optional_field(pdu, :receipted_message_id) nil iex(5)&gt; SMPPEX.Pdu.optional_field(pdu, :unknown_tlv_name) nil","ref":"SMPPEX.Pdu.html#optional_field/2","title":"SMPPEX.Pdu.optional_field/2","type":"function"},{"doc":"Get the whole set of optional(TLV) fields as a map.Examplesiex(1)&gt; pdu = SMPPEX.Pdu.new(4, %{short_message: &quot;hi&quot;}, %{0x0424 =&gt; &quot;hello&quot;}) iex(2)&gt; SMPPEX.Pdu.optional_fields(pdu) %{0x0424 =&gt; &quot;hello&quot;}","ref":"SMPPEX.Pdu.html#optional_fields/1","title":"SMPPEX.Pdu.optional_fields/1","type":"function"},{"doc":"Returns Pdu's unique reference ref.Examplesiex(1)&gt; pdu = SMPPEX.Pdu.new({1, 4, 123}) iex(2)&gt; is_reference SMPPEX.Pdu.ref(pdu) true","ref":"SMPPEX.Pdu.html#ref/1","title":"SMPPEX.Pdu.ref/1","type":"function"},{"doc":"Checks if Pdu is a response Pdu.Examplesiex(1)&gt; pdu = SMPPEX.Pdu.new(4) iex(2)&gt; SMPPEX.Pdu.resp?(pdu) false iex(3)&gt; pdu = SMPPEX.Pdu.new(0x80000004) iex(4)&gt; SMPPEX.Pdu.resp?(pdu) true","ref":"SMPPEX.Pdu.html#resp?/1","title":"SMPPEX.Pdu.resp?/1","type":"function"},{"doc":"Checks if two Pdus are copies of the same Pdu.Examplesiex(1)&gt; pdu1 = SMPPEX.Pdu.new(4) iex(2)&gt; pdu2 = SMPPEX.Pdu.new(4) iex(3)&gt; SMPPEX.Pdu.same?(pdu1, pdu2) false iex(4)&gt; SMPPEX.Pdu.same?(pdu1, pdu1) true","ref":"SMPPEX.Pdu.html#same?/2","title":"SMPPEX.Pdu.same?/2","type":"function"},{"doc":"Returns Pdu's sequence_number.Examplesiex(1)&gt; pdu = SMPPEX.Pdu.new({1, 4, 123}) iex(2)&gt; SMPPEX.Pdu.sequence_number(pdu) 123","ref":"SMPPEX.Pdu.html#sequence_number/1","title":"SMPPEX.Pdu.sequence_number/1","type":"function"},{"doc":"Sets Pdu mandatory field. New Pdu is returned.Examplesiex(1)&gt; pdu = SMPPEX.Pdu.new({1, 4, 123}, %{system_id: &quot;system_id&quot;}) iex(2)&gt; pdu1 = SMPPEX.Pdu.set_mandatory_field(pdu, :password, &quot;pass&quot;) iex(3)&gt; SMPPEX.Pdu.mandatory_field(pdu1, :password) &quot;pass&quot;","ref":"SMPPEX.Pdu.html#set_mandatory_field/3","title":"SMPPEX.Pdu.set_mandatory_field/3","type":"function"},{"doc":"Sets Pdu optional field. New Pdu is returned.Examplesiex(1)&gt; pdu = SMPPEX.Pdu.new(4) iex(2)&gt; pdu1 = SMPPEX.Pdu.set_optional_field(pdu, :message_payload, &quot;hello&quot;) iex(3)&gt; SMPPEX.Pdu.optional_field(pdu1, 0x0424) &quot;hello&quot;","ref":"SMPPEX.Pdu.html#set_optional_field/3","title":"SMPPEX.Pdu.set_optional_field/3","type":"function"},{"doc":"Returns Pdu's :source_addr, :source_addr_ton and :source_addr_npi fields in a tuple.Examplesiex(1)&gt; pdu = SMPPEX.Pdu.new(4, %{source_addr: &quot;from&quot;, source_addr_ton: 1, source_addr_npi: 2}) iex(2)&gt; SMPPEX.Pdu.source(pdu) {&quot;from&quot;, 1, 2}","ref":"SMPPEX.Pdu.html#source/1","title":"SMPPEX.Pdu.source/1","type":"function"},{"doc":"Checks if Pdu is a successful response Pdu.Examplesiex(1)&gt; pdu = SMPPEX.Pdu.new({0x80000004, 1, 0}) iex(2)&gt; SMPPEX.Pdu.success_resp?(pdu) false iex(3)&gt; pdu = SMPPEX.Pdu.new({0x80000004, 0, 0}) iex(4)&gt; SMPPEX.Pdu.success_resp?(pdu) true","ref":"SMPPEX.Pdu.html#success_resp?/1","title":"SMPPEX.Pdu.success_resp?/1","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.html#t:addr/0","title":"SMPPEX.Pdu.addr/0","type":"type"},{"doc":"","ref":"SMPPEX.Pdu.html#t:header/0","title":"SMPPEX.Pdu.header/0","type":"type"},{"doc":"","ref":"SMPPEX.Pdu.html#t:t/0","title":"SMPPEX.Pdu.t/0","type":"type"},{"doc":"Module for operating with SMPP errors.","ref":"SMPPEX.Pdu.Errors.html","title":"SMPPEX.Pdu.Errors","type":"module"},{"doc":"Converts atom representing SMPP error to its integer value.Example:iex(1)&gt; SMPPEX.Pdu.Errors.code_by_name(:ROK) 0","ref":"SMPPEX.Pdu.Errors.html#code_by_name/1","title":"SMPPEX.Pdu.Errors.code_by_name/1","type":"function"},{"doc":"Converts integer SMPP error code to text error description.Exampleiex(1)&gt; SMPPEX.Pdu.Errors.description(0) &quot;No Error&quot; iex(2)&gt; SMPPEX.Pdu.Errors.description(12345) &quot;12345&quot;","ref":"SMPPEX.Pdu.Errors.html#description/1","title":"SMPPEX.Pdu.Errors.description/1","type":"function"},{"doc":"Converts integer SMPP error code to string error identifier.Exampleiex(1)&gt; SMPPEX.Pdu.Errors.format(0) &quot;ROK&quot; iex(2)&gt; SMPPEX.Pdu.Errors.format(12345) &quot;12345&quot;","ref":"SMPPEX.Pdu.Errors.html#format/1","title":"SMPPEX.Pdu.Errors.format/1","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Errors.html#t:error_code/0","title":"SMPPEX.Pdu.Errors.error_code/0","type":"type"},{"doc":"","ref":"SMPPEX.Pdu.Errors.html#t:error_name/0","title":"SMPPEX.Pdu.Errors.error_name/0","type":"type"},{"doc":"Module for convenient generation of the most common PDUs.","ref":"SMPPEX.Pdu.Factory.html","title":"SMPPEX.Pdu.Factory","type":"module"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#bind/2","title":"SMPPEX.Pdu.Factory.bind/2","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#bind/4","title":"SMPPEX.Pdu.Factory.bind/4","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#bind_receiver/3","title":"SMPPEX.Pdu.Factory.bind_receiver/3","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#bind_receiver_resp/2","title":"SMPPEX.Pdu.Factory.bind_receiver_resp/2","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#bind_resp/3","title":"SMPPEX.Pdu.Factory.bind_resp/3","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#bind_transceiver/3","title":"SMPPEX.Pdu.Factory.bind_transceiver/3","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#bind_transceiver_resp/2","title":"SMPPEX.Pdu.Factory.bind_transceiver_resp/2","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#bind_transmitter/3","title":"SMPPEX.Pdu.Factory.bind_transmitter/3","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#bind_transmitter_resp/2","title":"SMPPEX.Pdu.Factory.bind_transmitter_resp/2","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#deliver_sm/3","title":"SMPPEX.Pdu.Factory.deliver_sm/3","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#deliver_sm_resp/1","title":"SMPPEX.Pdu.Factory.deliver_sm_resp/1","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#delivery_report/5","title":"SMPPEX.Pdu.Factory.delivery_report/5","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#delivery_report_for_submit_sm/4","title":"SMPPEX.Pdu.Factory.delivery_report_for_submit_sm/4","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#enquire_link/0","title":"SMPPEX.Pdu.Factory.enquire_link/0","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#enquire_link_resp/1","title":"SMPPEX.Pdu.Factory.enquire_link_resp/1","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#submit_sm/4","title":"SMPPEX.Pdu.Factory.submit_sm/4","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#submit_sm_resp/2","title":"SMPPEX.Pdu.Factory.submit_sm_resp/2","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#unbind/0","title":"SMPPEX.Pdu.Factory.unbind/0","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#unbind_resp/1","title":"SMPPEX.Pdu.Factory.unbind_resp/1","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#t:message/0","title":"SMPPEX.Pdu.Factory.message/0","type":"type"},{"doc":"","ref":"SMPPEX.Pdu.Factory.html#t:message_state/0","title":"SMPPEX.Pdu.Factory.message_state/0","type":"type"},{"doc":"Module for operating with deliver_sm message states.","ref":"SMPPEX.Pdu.MessageState.html","title":"SMPPEX.Pdu.MessageState","type":"module"},{"doc":"Converts atom representing message state to integer value.Exampleiex(1)&gt; SMPPEX.Pdu.MessageState.code_by_name(:DELIVERED) 2","ref":"SMPPEX.Pdu.MessageState.html#code_by_name/1","title":"SMPPEX.Pdu.MessageState.code_by_name/1","type":"function"},{"doc":"Converts integer message state value to string representation.Exampleiex(1)&gt; SMPPEX.Pdu.MessageState.format(2) &quot;DELIVERED&quot; iex(2)&gt; SMPPEX.Pdu.MessageState.format(12345) &quot;12345&quot;","ref":"SMPPEX.Pdu.MessageState.html#format/1","title":"SMPPEX.Pdu.MessageState.format/1","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.MessageState.html#t:state/0","title":"SMPPEX.Pdu.MessageState.state/0","type":"type"},{"doc":"","ref":"SMPPEX.Pdu.MessageState.html#t:state_name/0","title":"SMPPEX.Pdu.MessageState.state_name/0","type":"type"},{"doc":"Module for operating with multipart information packed as UDH in message body.","ref":"SMPPEX.Pdu.Multipart.html","title":"SMPPEX.Pdu.Multipart","type":"module"},{"doc":"Extracts multipart information from PDU or directly from binary message. This function is deprecated. Use extract_from_pdu/1 or extract_from_message/1 instead.Returns one of the following:{:ok, :single, message} if the message does not contain any multipart information and represents a single message;{:ok, {ref_num, count, seq_num}, message} if the original message contains multipart information in UDH fields. The outcoming message is cleared from UDH bytes.{:error, reason}Exampleiex&gt; data = &lt;&lt;0x05, 0x00, 0x03, 0x03, 0x02, 0x01, &quot;message&quot;&gt;&gt; iex&gt; SMPPEX.Pdu.Multipart.extract(data) {:ok, {3,2,1}, &quot;message&quot;} iex&gt; data = &lt;&lt;0x06, 0x08, 0x04, 0x00, 0x03, 0x02, 0x01, &quot;message&quot;&gt;&gt; iex&gt; SMPPEX.Pdu.Multipart.extract(data) {:ok, {3,2,1}, &quot;message&quot;} iex&gt; pdu = Pdu.new({1,0,1}, %{esm_class: 0b01000000, short_message: &lt;&lt;0x05, 0x00, 0x03, 0x03, 0x02, 0x01, &quot;message&quot;&gt;&gt;}) iex&gt; SMPPEX.Pdu.Multipart.extract(pdu) {:ok, {3,2,1}, &quot;message&quot;} iex&gt; pdu = Pdu.new({1,0,1}, %{short_message: &lt;&lt;0x05, 0x00, 0x03, 0x03, 0x02, 0x01, &quot;message&quot;&gt;&gt;}) iex&gt; SMPPEX.Pdu.Multipart.extract(pdu) {:error, &quot;Message is not multipart&quot;}","ref":"SMPPEX.Pdu.Multipart.html#extract/1","title":"SMPPEX.Pdu.Multipart.extract/1","type":"function"},{"doc":"Extracts multipart information from already parsed list of UDH IEs.Return one of the following:{:ok, :single} if IEs do not contain any multipart message related ones;{:ok, {ref_num, count, seq_num}} if there are multipart message related IEs (the first is taken);{:error, reason} in case of errors.Exampleiex&gt; ies = [{0, &lt;&lt;0x03, 0x02, 0x01&gt;&gt;}] iex&gt; SMPPEX.Pdu.Multipart.extract_from_ies(ies) {:ok, {3, 2, 1}} iex&gt; ies = [{0, &lt;&lt;0x03, 0x02, 0x01&gt;&gt;}, {8, &lt;&lt;0x00, 0x04, 0x02, 0x01&gt;&gt;}] iex&gt; SMPPEX.Pdu.Multipart.extract_from_ies(ies) {:ok, {3, 2, 1}} iex&gt; ies = [{8, &lt;&lt;0x00, 0x03, 0x02, 0x01&gt;&gt;}] iex&gt; SMPPEX.Pdu.Multipart.extract_from_ies(ies) {:ok, {3, 2, 1}} iex&gt; ies = [{8, &lt;&lt;0x00, 0x03, 0x02&gt;&gt;}] iex&gt; SMPPEX.Pdu.Multipart.extract_from_ies(ies) {:error, &quot;Invalid 16bit refrence number concatenated short messages info&quot;} iex&gt; ies = [] iex&gt; SMPPEX.Pdu.Multipart.extract_from_ies(ies) {:ok, :single}","ref":"SMPPEX.Pdu.Multipart.html#extract_from_ies/1","title":"SMPPEX.Pdu.Multipart.extract_from_ies/1","type":"function"},{"doc":"Extracts multipart information from binary message.Returns one of the following:{:ok, :single, message} if the message does not contain any multipart information and represents a single message. The outcoming message is cleared from UDH bytes.{:ok, {ref_num, count, seq_num}, message} if the original message contains multipart information in UDH fields. The outcoming message is cleared from UDH bytes.{:error, reason}Exampleiex&gt; data = &lt;&lt;0x05, 0x00, 0x03, 0x03, 0x02, 0x01, &quot;message&quot;&gt;&gt; iex&gt; SMPPEX.Pdu.Multipart.extract_from_message(data) {:ok, {3,2,1}, &quot;message&quot;} iex&gt; data = &lt;&lt;0x06, 0x08, 0x04, 0x00, 0x03, 0x02, 0x01, &quot;message&quot;&gt;&gt; iex&gt; SMPPEX.Pdu.Multipart.extract_from_message(data) {:ok, {3,2,1}, &quot;message&quot;}","ref":"SMPPEX.Pdu.Multipart.html#extract_from_message/1","title":"SMPPEX.Pdu.Multipart.extract_from_message/1","type":"function"},{"doc":"Extracts multipart information from PDU.Returns one of the following:{:ok, :single, message} if the message does not contain any multipart information and represents a single message. The outcoming message is cleared from UDH bytes.{:ok, {ref_num, count, seq_num}, message} if the original message contains multipart information in UDH fields. The outcoming message is cleared from UDH bytes.{:error, reason}Exampleiex&gt; pdu = Pdu.new({1,0,1}, %{esm_class: 0b01000000, short_message: &lt;&lt;0x05, 0x00, 0x03, 0x03, 0x02, 0x01, &quot;message&quot;&gt;&gt;}) iex&gt; SMPPEX.Pdu.Multipart.extract_from_pdu(pdu) {:ok, {3,2,1}, &quot;message&quot;} iex&gt; pdu = Pdu.new({1,0,1}, %{short_message: &lt;&lt;0x05, 0x00, 0x03, 0x03, 0x02, 0x01, &quot;message&quot;&gt;&gt;}) iex&gt; SMPPEX.Pdu.Multipart.extract_from_pdu(pdu) {:error, &quot;Message is not multipart&quot;}","ref":"SMPPEX.Pdu.Multipart.html#extract_from_pdu/1","title":"SMPPEX.Pdu.Multipart.extract_from_pdu/1","type":"function"},{"doc":"Generates IE encoding multipart information.Exampleiex&gt; SMPPEX.Pdu.Multipart.multipart_ie({3,2,1}) {:ok, {0, &lt;&lt;0x03, 0x02, 0x01&gt;&gt;}} iex&gt; SMPPEX.Pdu.Multipart.multipart_ie({256,2,1}) {:ok, {8, &lt;&lt;0x01, 0x00, 0x02, 0x01&gt;&gt;}} iex&gt; SMPPEX.Pdu.Multipart.multipart_ie({1, 1, 256}) {:error, &quot;Invalid sequence number in multipart info&quot;}","ref":"SMPPEX.Pdu.Multipart.html#multipart_ie/1","title":"SMPPEX.Pdu.Multipart.multipart_ie/1","type":"function"},{"doc":"Prepends message with multipart info encoded as UDH.Exampleiex&gt; SMPPEX.Pdu.Multipart.prepend_message_with_part_info({3,2,1}, &quot;message&quot;) {:ok, &lt;&lt;0x05, 0x00, 0x03, 0x03, 0x02, 0x01, &quot;message&quot;&gt;&gt;} iex&gt; SMPPEX.Pdu.Multipart.prepend_message_with_part_info({256,2,1}, &quot;message&quot;) {:ok, &lt;&lt;0x06, 0x08, 0x04, 0x01, 0x00, 0x02, 0x01, &quot;message&quot;&gt;&gt;}","ref":"SMPPEX.Pdu.Multipart.html#prepend_message_with_part_info/2","title":"SMPPEX.Pdu.Multipart.prepend_message_with_part_info/2","type":"function"},{"doc":"Splits message into parts prepending each part with multipart information UDH so that the resulting size of each part does not exceed max_len bytes.The result is one of the following:{:ok, :unsplit} if the message already fits into max_len bytes;{:ok, :split, parts} if the message was succesfully split into parts;{:error, reason} in case of errors.Exampleiex&gt; SMPPEX.Pdu.Multipart.split_message(123, &quot;abc&quot;, 3) {:ok, :unsplit} iex&gt; SMPPEX.Pdu.Multipart.split_message(123, &quot;abcdefg&quot;, 6) {:error, &quot;Invalid limits for splitting message&quot;} iex&gt; SMPPEX.Pdu.Multipart.split_message(123, &quot;abcdefghi&quot;, 8) {:ok, :split, [ &lt;&lt;0x05, 0x00, 0x03, 0x7b, 0x05, 0x01, &quot;ab&quot;&gt;&gt;, &lt;&lt;0x05, 0x00, 0x03, 0x7b, 0x05, 0x02, &quot;cd&quot;&gt;&gt;, &lt;&lt;0x05, 0x00, 0x03, 0x7b, 0x05, 0x03, &quot;ef&quot;&gt;&gt;, &lt;&lt;0x05, 0x00, 0x03, 0x7b, 0x05, 0x04, &quot;gh&quot;&gt;&gt;, &lt;&lt;0x05, 0x00, 0x03, 0x7b, 0x05, 0x05, &quot;i&quot;&gt;&gt; ]}","ref":"SMPPEX.Pdu.Multipart.html#split_message/3","title":"SMPPEX.Pdu.Multipart.split_message/3","type":"function"},{"doc":"Splits message into parts not exceeding max_split bytes and prepending each part with multipart information UDH. The message is not split if its size does not exceed max_len bytes.The results format is the same as in split_message/3.Exampleiex&gt; SMPPEX.Pdu.Multipart.split_message(123, &quot;abcdefghi&quot;, 0, 2) {:ok, :split, [ &lt;&lt;0x05, 0x00, 0x03, 0x7b, 0x05, 0x01, &quot;ab&quot;&gt;&gt;, &lt;&lt;0x05, 0x00, 0x03, 0x7b, 0x05, 0x02, &quot;cd&quot;&gt;&gt;, &lt;&lt;0x05, 0x00, 0x03, 0x7b, 0x05, 0x03, &quot;ef&quot;&gt;&gt;, &lt;&lt;0x05, 0x00, 0x03, 0x7b, 0x05, 0x04, &quot;gh&quot;&gt;&gt;, &lt;&lt;0x05, 0x00, 0x03, 0x7b, 0x05, 0x05, &quot;i&quot;&gt;&gt; ]}","ref":"SMPPEX.Pdu.Multipart.html#split_message/4","title":"SMPPEX.Pdu.Multipart.split_message/4","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Multipart.html#t:actual_part_info/0","title":"SMPPEX.Pdu.Multipart.actual_part_info/0","type":"type"},{"doc":"","ref":"SMPPEX.Pdu.Multipart.html#t:extract_result/0","title":"SMPPEX.Pdu.Multipart.extract_result/0","type":"type"},{"doc":"","ref":"SMPPEX.Pdu.Multipart.html#t:part_info/0","title":"SMPPEX.Pdu.Multipart.part_info/0","type":"type"},{"doc":"","ref":"SMPPEX.Pdu.Multipart.html#t:split_result/0","title":"SMPPEX.Pdu.Multipart.split_result/0","type":"type"},{"doc":"Module for operating with deliver_sm network_error_code parameter.","ref":"SMPPEX.Pdu.NetworkErrorCode.html","title":"SMPPEX.Pdu.NetworkErrorCode","type":"module"},{"doc":"Converts octet_string from network_error_code tag to type_code and error_valueExampleiex(1)&gt; SMPPEX.Pdu.NetworkErrorCode.decode(&lt;&lt;08,00,01&gt;&gt;) {8, 1}","ref":"SMPPEX.Pdu.NetworkErrorCode.html#decode/1","title":"SMPPEX.Pdu.NetworkErrorCode.decode/1","type":"function"},{"doc":"Converts network_error_code type and error to octet stringExampleiex(1)&gt; SMPPEX.Pdu.NetworkErrorCode.encode(8,1) &lt;&lt;08,00,01&gt;&gt;","ref":"SMPPEX.Pdu.NetworkErrorCode.html#encode/2","title":"SMPPEX.Pdu.NetworkErrorCode.encode/2","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.NetworkErrorCode.html#t:error_code/0","title":"SMPPEX.Pdu.NetworkErrorCode.error_code/0","type":"type"},{"doc":"","ref":"SMPPEX.Pdu.NetworkErrorCode.html#t:network_error_code/0","title":"SMPPEX.Pdu.NetworkErrorCode.network_error_code/0","type":"type"},{"doc":"","ref":"SMPPEX.Pdu.NetworkErrorCode.html#t:type_code/0","title":"SMPPEX.Pdu.NetworkErrorCode.type_code/0","type":"type"},{"doc":"Module for converting SMPPEX Pdu structs to format used by Oserl library.","ref":"SMPPEX.Pdu.Oserl.html","title":"SMPPEX.Pdu.Oserl","type":"module"},{"doc":"Converts PDU from Oserl format to SMPPEX Pdu.","ref":"SMPPEX.Pdu.Oserl.html#from/1","title":"SMPPEX.Pdu.Oserl.from/1","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Oserl.html#network_error_code/1","title":"SMPPEX.Pdu.Oserl.network_error_code/1","type":"macro"},{"doc":"","ref":"SMPPEX.Pdu.Oserl.html#network_error_code/2","title":"SMPPEX.Pdu.Oserl.network_error_code/2","type":"macro"},{"doc":"Converts SMPPEX Pdu to Oserl format.Unknown optional values are ignored, since Oserl stores them by symbolic names.","ref":"SMPPEX.Pdu.Oserl.html#to/1","title":"SMPPEX.Pdu.Oserl.to/1","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.Oserl.html#t:t/0","title":"SMPPEX.Pdu.Oserl.t/0","type":"type"},{"doc":"Module for colored pretty printing Pdu structs.","ref":"SMPPEX.Pdu.PP.html","title":"SMPPEX.Pdu.PP","type":"module"},{"doc":"Forms an iolist containing colored Pdu dump.indent is the string prepended to each line of the dump (&quot; &quot; by default). pad is the string prepended to nested lines of the dump together with indent. The default is &quot;&quot;.Exampleiex&gt; pdu = SMPPEX.Pdu.Factory.submit_sm({&quot;from&quot;, 1, 1}, {&quot;to&quot;, 1, 1}, &quot;hello&quot;)Then pdu |&gt; SMPPEX.Pdu.PP.format |&gt; IO.puts will print:pdu: submit_sm command_id: 4 command_status: 0 (ok) sequence_number: 0 mandatory fields: dest_addr_npi: 1 dest_addr_ton: 1 destination_addr: &quot;to&quot; registered_delivery: 0 short_message: &quot;hello&quot; source_addr: &quot;from&quot; source_addr_npi: 1 source_addr_ton: 1 optional fields: []","ref":"SMPPEX.Pdu.PP.html#format/3","title":"SMPPEX.Pdu.PP.format/3","type":"function"},{"doc":"Module for automatic TON/NPI detection","ref":"SMPPEX.Pdu.TONNPIDefaults.html","title":"SMPPEX.Pdu.TONNPIDefaults","type":"module"},{"doc":"","ref":"SMPPEX.Pdu.TONNPIDefaults.html#ton_npi/1","title":"SMPPEX.Pdu.TONNPIDefaults.ton_npi/1","type":"function"},{"doc":"Module for parsing encoded IEs from UDHs.","ref":"SMPPEX.Pdu.UDH.html","title":"SMPPEX.Pdu.UDH","type":"module"},{"doc":"Encodes IEs and prepends message with the encoded value.The result is one of the following:{:ok, message} where message is the original message prefixed with UDH;{:error, reason} in case of errors.Exampleiex&gt; ies = [{0x05, &lt;&lt;0x06, 0x2d, 0x00, 0x00&gt;&gt;}, {0x00, &lt;&lt;0x01, 0x02, 0x01&gt;&gt;}] iex&gt; SMPPEX.Pdu.UDH.add(ies, &quot;message&quot;) {:ok, &lt;&lt;0x0B, 0x05, 0x04, 0x06, 0x2d, 0x00, 0x00, 0x00, 0x03, 0x01, 0x02, 0x01, &quot;message&quot;&gt;&gt;} iex&gt; ies = [{0, 123}] iex&gt; SMPPEX.Pdu.UDH.add(ies, &quot;message&quot;) {:error, &quot;Invalid UDH IE data&quot;} iex&gt; ies = [{345, &quot;ie&quot;}] iex&gt; SMPPEX.Pdu.UDH.add(ies, &quot;message&quot;) {:error, &quot;Invalid UDH IE id&quot;} iex&gt; ies = [{-1, &quot;ie&quot;}] iex&gt; SMPPEX.Pdu.UDH.add(ies, &quot;message&quot;) {:error, &quot;Invalid UDH IE id&quot;} iex&gt; ies = [{0, &lt;&lt;1 :: integer-size(2040)&gt;&gt;}] iex&gt; SMPPEX.Pdu.UDH.add(ies, &quot;message&quot;) {:error, &quot;UDH is too long&quot;}","ref":"SMPPEX.Pdu.UDH.html#add/2","title":"SMPPEX.Pdu.UDH.add/2","type":"function"},{"doc":"Extracts list of IEs from UDH.Returns one of the following{:ok, ies, message} where ies is a list of IE tuples {id, value} and message is the original message without UDH;{:error, reason} in case of errors.Exampleiex&gt; data = &lt;&lt;5, 0, 3, 197, 3, 3, &quot;message&quot;&gt;&gt; iex&gt; SMPPEX.Pdu.UDH.extract(data) {:ok, [{0, &lt;&lt;197, 3, 3&gt;&gt;}], &quot;message&quot;} iex&gt; data = &lt;&lt;0x0B, 0x05, 0x04, 0x06, 0x2d, 0x00, 0x00, 0x00, 0x03, 0x01, 0x02, 0x01, &quot;message&quot;&gt;&gt; iex&gt; SMPPEX.Pdu.UDH.extract(data) {:ok, [{0x05, &lt;&lt;0x06, 0x2d, 0x00, 0x00&gt;&gt;}, {0x00, &lt;&lt;0x01, 0x02, 0x01&gt;&gt;}], &quot;message&quot;} iex&gt; data = &lt;&lt;0x10, &quot;short&quot;&gt;&gt; iex&gt; SMPPEX.Pdu.UDH.extract(data) {:error, &quot;Invalid UDH length&quot;} iex&gt; data = &lt;&lt;0x06, 0x00, 0x03, 0x01, 0x02, 0x01, &quot;message&quot;&gt;&gt; iex&gt; SMPPEX.Pdu.UDH.extract(data) {:error, &quot;Invalid UDH data&quot;} iex&gt; data = &lt;&lt;5, 0, 4, 197, 3, 3, &quot;message&quot;&gt;&gt; iex&gt; SMPPEX.Pdu.UDH.extract(data) {:error, &quot;Invalid UDH IE length&quot;}","ref":"SMPPEX.Pdu.UDH.html#extract/1","title":"SMPPEX.Pdu.UDH.extract/1","type":"function"},{"doc":"Checks if message in PDU has UDH (by inspecting esm_class field).Exampleiex&gt; pdu = SMPPEX.Pdu.new({1,0,1}, %{esm_class: 0}, %{}) iex&gt; SMPPEX.Pdu.UDH.has_udh?(pdu) false iex&gt; pdu = SMPPEX.Pdu.new({1,0,1}, %{esm_class: 0b01000000}, %{}) iex&gt; SMPPEX.Pdu.UDH.has_udh?(pdu) true","ref":"SMPPEX.Pdu.UDH.html#has_udh?/1","title":"SMPPEX.Pdu.UDH.has_udh?/1","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.UDH.html#t:ie/0","title":"SMPPEX.Pdu.UDH.ie/0","type":"type"},{"doc":"Module for converting validity period to Unix timestamp.Module works both with the absolute format of validity period and with the relative one. In case of relative validity period, this module implements a naive representation of the month and year date shifting for the sake of simplicity.","ref":"SMPPEX.Pdu.ValidityPeriod.html","title":"SMPPEX.Pdu.ValidityPeriod","type":"module"},{"doc":"Converts validity_period/0 to Unix timestamp according to the SMPP specification.In case of the relative format, this function uses a naive implementation of the month and date shifting. To be clear, it takes one month as 30 days and one year as 12 months.One who uses the function should implement the way how this time shift might be limited according to the SMPP specification:A MC operator may choose to impose a limit on relative time offsets, thus either rejecting a message that exceeds such a limit or reducing the offset to the maximum relative time allowed.Returns {:ok, timestamp} if conversion was successful.Returns {:error, :invalid_validity_period} if validity_period is not consistent with the SMPP specification.In case of internal errors, however, this function raises an exception.Example (relative format)iex&gt; timestamp_origin = ~N[2017-01-01 00:00:00] |&gt; ...&gt; DateTime.from_naive!(&quot;Etc/UTC&quot;) |&gt; ...&gt; DateTime.to_unix() iex&gt; timestamp = SMPPEX.Pdu.ValidityPeriod.to_timestamp!(&quot;000000000005000R&quot;, timestamp_origin) iex&gt; DateTime.from_unix!(timestamp) |&gt; to_string() &quot;2017-01-01 00:00:05Z&quot;Example (absolute format)iex&gt; {:ok, timestamp} = SMPPEX.Pdu.ValidityPeriod.to_timestamp(&quot;170610233429004+&quot;) iex&gt; DateTime.from_unix!(timestamp) |&gt; to_string() &quot;2017-06-10 22:34:29Z&quot;","ref":"SMPPEX.Pdu.ValidityPeriod.html#to_timestamp/2","title":"SMPPEX.Pdu.ValidityPeriod.to_timestamp/2","type":"function"},{"doc":"Converts validity_period/0 to Unix timestamp according to the SMPP specification. The same as to_timestamp/2 but raises an exception in case of error.","ref":"SMPPEX.Pdu.ValidityPeriod.html#to_timestamp!/2","title":"SMPPEX.Pdu.ValidityPeriod.to_timestamp!/2","type":"function"},{"doc":"","ref":"SMPPEX.Pdu.ValidityPeriod.html#t:timestamp/0","title":"SMPPEX.Pdu.ValidityPeriod.timestamp/0","type":"type"},{"doc":"","ref":"SMPPEX.Pdu.ValidityPeriod.html#t:timestamp_origin/0","title":"SMPPEX.Pdu.ValidityPeriod.timestamp_origin/0","type":"type"},{"doc":"","ref":"SMPPEX.Pdu.ValidityPeriod.html#t:validity_period/0","title":"SMPPEX.Pdu.ValidityPeriod.validity_period/0","type":"type"},{"doc":"Module for implementing custom SMPP Session entities.To implement an Session entitiy, one should implement several callbacks (SMPPEX.Session behaviour). The most proper way to do it is to use SMPPEX.Session:defmodule MySession do use SMPPEX.Session # ...Callback implementation endIn this case all callbacks have reasonable defaults.","ref":"SMPPEX.Session.html","title":"SMPPEX.Session","type":"behaviour"},{"doc":"Makes a syncronous call to the session.The call is handled by handle_call/3 SMPPEX.Session callback.","ref":"SMPPEX.Session.html#call/3","title":"SMPPEX.Session.call/3","type":"function"},{"doc":"Makes an asyncronous call to Session.The call is handled by handle_cast/2 SMPPEX.Session callback.","ref":"SMPPEX.Session.html#cast/2","title":"SMPPEX.Session.cast/2","type":"function"},{"doc":"Callback implementation for c:SMPPEX.TransportSession.code_change/3.","ref":"SMPPEX.Session.html#code_change/3","title":"SMPPEX.Session.code_change/3","type":"function"},{"doc":"Invoked to change the state of the session when a different version of a module is loaded (hot code swapping) and the state’s term structure should be changed. The method has the same semantics as the original GenServer.code_change/3 callback.","ref":"SMPPEX.Session.html#c:code_change/3","title":"SMPPEX.Session.code_change/3","type":"callback"},{"doc":"Callback implementation for c:SMPPEX.TransportSession.handle_call/3.","ref":"SMPPEX.Session.html#handle_call/3","title":"SMPPEX.Session.handle_call/3","type":"function"},{"doc":"Invoked to handle an arbitrary syncronous request sent to the session with Session.call/3 method.from argument can be used to send a response asyncronously via Session.reply/2.The returned values indicate the following:{:reply, reply, state} — reply with reply and use state as the new state;{:reply, reply, pdus, state} — reply with reply, use state as the new state and additionally send pdus to the peer;{:noreply, state} — do not reply and use state as the new state. The reply can be send later via Session.reply;{:noreply, pdus, state} — do not reply, use state as the new state and additionally send pdus to the peer. The reply can be send later via Session.reply;{:stop, reason, reply, state} — reply with reply, use state as the new state and exit with reason;{:stop, reason, state} — do not reply, use state as the new state and exit with reason.","ref":"SMPPEX.Session.html#c:handle_call/3","title":"SMPPEX.Session.handle_call/3","type":"callback"},{"doc":"Callback implementation for c:SMPPEX.TransportSession.handle_cast/2.","ref":"SMPPEX.Session.html#handle_cast/2","title":"SMPPEX.Session.handle_cast/2","type":"function"},{"doc":"Invoked to handle an arbitrary asyncronous request sent to the session with Session.cast/2 method.The returned values indicate the following:{:noreply, state} — use state as the new state;{:noreply, pdus, state} — use state as the new state and additionally send pdus to the peer.;{:stop, reason, state} — use state as the new state and exit with reason.","ref":"SMPPEX.Session.html#c:handle_cast/2","title":"SMPPEX.Session.handle_cast/2","type":"callback"},{"doc":"Invoked to handle a generic message request sent to the session process.The returned values indicate the following:{:noreply, state} — use state as the new state;{:noreply, pdus, state} — use state as the new state and additionally send pdus to the peer.;{:stop, reason, state} — use state as the new state and exit with reason.","ref":"SMPPEX.Session.html#c:handle_info/2","title":"SMPPEX.Session.handle_info/2","type":"callback"},{"doc":"Callback implementation for c:SMPPEX.TransportSession.handle_pdu/2.","ref":"SMPPEX.Session.html#handle_pdu/2","title":"SMPPEX.Session.handle_pdu/2","type":"function"},{"doc":"Invoked when the session receives an incoming PDU (which is not a response PDU).The callback return values indicate the following:{:ok, state} — use state as the new session state;{:ok, pdus, state} — use state as the new session state and additionally send pdus to the connection;{:stop, reason, state} — stop with reason reason and use state as the new session state.","ref":"SMPPEX.Session.html#c:handle_pdu/2","title":"SMPPEX.Session.handle_pdu/2","type":"callback"},{"doc":"Invoked when the session receives a response to a previously sent PDU.pdu argument contains the received response PDU, original_pdu contains the previously sent pdu for which the handled response is received.The callback return values indicate the following:{:ok, state} — use state as the new session state;{:ok, pdus, state} — use state as the new session state and additionally send pdus to the connection;{:stop, reason, state} — stop with reason reason and use state as the new session state.","ref":"SMPPEX.Session.html#c:handle_resp/3","title":"SMPPEX.Session.handle_resp/3","type":"callback"},{"doc":"Invoked when the session does not receive a response to a previously sent PDU within the specified timeout.pdu argument contains the PDU for which no response was received. If the response will be received later it will be dropped (with an info log message).The callback return values indicate the following:{:ok, state} — use state as the new session state;{:ok, pdus, state} — use state as the new session state and additionally send pdus to the connection;{:stop, reason, state} — stop with reason reason and use state as the new session state.","ref":"SMPPEX.Session.html#c:handle_resp_timeout/2","title":"SMPPEX.Session.handle_resp_timeout/2","type":"callback"},{"doc":"Callback implementation for c:SMPPEX.TransportSession.handle_send_pdu_result/3.","ref":"SMPPEX.Session.html#handle_send_pdu_result/3","title":"SMPPEX.Session.handle_send_pdu_result/3","type":"function"},{"doc":"Invoked when the SMPP session successfully sent PDU to transport or failed to do this.pdu argument contains the PDU for which send status is reported. send_pdu_result can be either :ok or {:error, reason}.The returned value is used as the new state.","ref":"SMPPEX.Session.html#c:handle_send_pdu_result/3","title":"SMPPEX.Session.handle_send_pdu_result/3","type":"callback"},{"doc":"Callback implementation for c:SMPPEX.TransportSession.handle_socket_closed/1.","ref":"SMPPEX.Session.html#handle_socket_closed/1","title":"SMPPEX.Session.handle_socket_closed/1","type":"function"},{"doc":"Invoked when the connection is closed by the peer.The returned value should be {reason, state}. The session stops then with reason.","ref":"SMPPEX.Session.html#c:handle_socket_closed/1","title":"SMPPEX.Session.handle_socket_closed/1","type":"callback"},{"doc":"Callback implementation for c:SMPPEX.TransportSession.handle_socket_error/2.","ref":"SMPPEX.Session.html#handle_socket_error/2","title":"SMPPEX.Session.handle_socket_error/2","type":"function"},{"doc":"Invoked when the connection's socket reported a error.The returned value should be {reason, state}. The session stops then with reason.","ref":"SMPPEX.Session.html#c:handle_socket_error/2","title":"SMPPEX.Session.handle_socket_error/2","type":"callback"},{"doc":"Invoked when the session receives an incoming PDU which couldn't be correctly parsed.The callback return values indicate the following:{:ok, state} — use state as the new session state;{:ok, pdus, state} — use state as the new session state and additionally send pdus to the connection;{:stop, reason, state} — stop with reason reason and use state as the new session state.","ref":"SMPPEX.Session.html#c:handle_unparsed_pdu/3","title":"SMPPEX.Session.handle_unparsed_pdu/3","type":"callback"},{"doc":"Callback implementation for c:SMPPEX.TransportSession.init/3.","ref":"SMPPEX.Session.html#init/3","title":"SMPPEX.Session.init/3","type":"function"},{"doc":"Invoked when a session is started after a connection successfully established.args argument is taken directly from ESME.start_link or MC.start call. The return value should be either {:ok, state}, then the session will successfully start and the returned state will be later passed to the other callbacks, or {:stop, reason}, then the session will stop with the returned reason.","ref":"SMPPEX.Session.html#c:init/3","title":"SMPPEX.Session.init/3","type":"callback"},{"doc":"Replies to a client calling Session.call method.This function can be used to explicitly send a reply to a client that called call/3.from must be the from argument (the second argument) accepted by handle_call/3 callbacks. The return value is always :ok.","ref":"SMPPEX.Session.html#reply/2","title":"SMPPEX.Session.reply/2","type":"function"},{"doc":"Sends a PDU from the session to the peer.","ref":"SMPPEX.Session.html#send_pdu/3","title":"SMPPEX.Session.send_pdu/3","type":"function"},{"doc":"Stops the session syncronously.","ref":"SMPPEX.Session.html#stop/2","title":"SMPPEX.Session.stop/2","type":"function"},{"doc":"Callback implementation for c:SMPPEX.TransportSession.terminate/2.","ref":"SMPPEX.Session.html#terminate/2","title":"SMPPEX.Session.terminate/2","type":"function"},{"doc":"Invoked when the session process is about to exit.lost_pdus contain a list of nonresp pdus sent by the session to the peer and which have not yet received a response.The returned value is either :stop or {:stop, last_pdus, state}, where last_pdus is a list of PDUs which will be sent to the peer before socket close, and state is the new state. For example, an ESME can send an unbind PDU or an MC can send negative resps for pending submit_sms if needed.This callback is called from the underlying GenServer terminate callbacks, so it has all the corresponding caveats, for example, sometimes it may not be called, see GenServer.terminate/2 docs.","ref":"SMPPEX.Session.html#c:terminate/3","title":"SMPPEX.Session.terminate/3","type":"callback"},{"doc":"","ref":"SMPPEX.Session.html#t:from/0","title":"SMPPEX.Session.from/0","type":"type"},{"doc":"","ref":"SMPPEX.Session.html#t:reason/0","title":"SMPPEX.Session.reason/0","type":"type"},{"doc":"","ref":"SMPPEX.Session.html#t:reply/0","title":"SMPPEX.Session.reply/0","type":"type"},{"doc":"","ref":"SMPPEX.Session.html#t:request/0","title":"SMPPEX.Session.request/0","type":"type"},{"doc":"","ref":"SMPPEX.Session.html#t:send_pdu_result/0","title":"SMPPEX.Session.send_pdu_result/0","type":"type"},{"doc":"","ref":"SMPPEX.Session.html#t:session/0","title":"SMPPEX.Session.session/0","type":"type"},{"doc":"","ref":"SMPPEX.Session.html#t:state/0","title":"SMPPEX.Session.state/0","type":"type"},{"doc":"SMPPEX","ref":"examples.html","title":"SMPPEX","type":"extras"},{"doc":"SMPPEX is a framework for building SMPP servers and clients (which are often referred to as MC and ESME entities respectevely).The major features exposed by the library are:SMPPEX.ESME module and behaviour for implementing ESME entities;SMPPEX.MC module and behaviour for implementing MC entities;SMPPEX.ESME.Sync module representing simple ready to use SMPP client.Also one of the core features of the library is simplicity: both code simplicity and simplicity of use.The library does not have much TCP handling or session management functionality, it is based on great ranch library.SMPP session is symmetric(used both in ESME and MC) and is implemented as ranch_protocol behaviour.The library includes an easy and ready to use SMPP client (SMPP.ESME.Sync) which has capabilities of synchronous SMS sending and do not require implementing ESME behavior. There is also an SMPP testing tool smppsend based on this client.","ref":"examples.html#general-description","title":"SMPPEX - General description","type":"extras"},{"doc":"SMPPEX.ESME.Sync is the most straightforward way to interact with an SMSC. Example: {:ok, esme} = SMPPEX.ESME.Sync.start_link(host, port) bind = SMPPEX.Pdu.Factory.bind_transmitter(&quot;system_id&quot;, &quot;password&quot;) {:ok, _bind_resp} = SMPPEX.ESME.Sync.request(esme, bind) # We are bound, let&#39;s send a message submit_sm = SMPPEX.Pdu.Factory.submit_sm({&quot;from&quot;, 1, 1}, {&quot;to&quot;, 1, 1}, &quot;hello!&quot;) {:ok, submit_sm_resp} = SMPPEX.ESME.Sync.request(esme, submit_sm) # Message is sent, let&#39;s get the obtained id: message_id = SMPPEX.Pdu.field(submit_sm_resp, :message_id) # Now let&#39;s wait for a delivery report: delivery_report? = fn(pdu) -&gt; SMPPEX.Pdu.command_name(pdu) == :deliver_sm and SMPPEX.Pdu.field(pdu, :receipted_message_id) == message_id end delivery_reports = case SMPPEX.ESME.Sync.wait_for_pdus(esme, 60000) do :stop -&gt; Logger.info(&quot;Ooops, ESME stopped&quot;) [] :timeout -&gt; Logger.info(&quot;No DLR in 60 seconds&quot;) [] received_items -&gt; # Let&#39;s filter out DLRs for the previously submitted message for {:pdu, pdu} &lt;- received_items, delivery_report?.(pdu), do: pdu end","ref":"examples.html#smppex-esme-sync","title":"SMPPEX - SMPPEX.ESME.Sync","type":"extras"},{"doc":"SMPPEX.ESME can be used when more complicated client logic is needed, for example custom immediate reactions to all incoming PDUs, rps/window control, etc.SMPPEX.Session provides &quot;empty&quot; defaults for all required callbacks, so minimal ESME could be very simple:defmodule DummyESME do use SMPPEX.Session def start_link(host, port) do SMPPEX.ESME.start_link(host, port, {__MODULE__, []}) end endIt is still completely functional:{:ok, esme} = DummyESME.start_link(host, port) SMPPEX.Session.send_pdu(esme, SMPPEX.Pdu.Factory.bind_transmitter(&quot;system_id&quot;, &quot;password&quot;))Here's a more complicated example of ESME, which does the following:Receives port number and three arguments:waiting_pid — a pid of the process which will be informed when ESME stops;count — count of PDUs to send;window — window size, the maximum number of sent PDU's without resps.Connects to the specified port on localhost and issues a bind command.Starts to send predefined PDUs after bind at maximum possible rate but regarding window size.Stops after all PDUs are sent and notifies the waiting process.defmodule SMPPBenchmarks.ESME do use SMPPEX.Session require Logger @from {&quot;from&quot;, 1, 1} @to {&quot;to&quot;, 1, 1} @message &quot;hello&quot; @system_id &quot;system_id&quot; @password &quot;password&quot; def start_link(port, waiting_pid, count, window) do SMPPEX.ESME.start_link(&quot;127.0.0.1&quot;, port, {__MODULE__, [waiting_pid, count, window]}) end def init(_, _, [waiting_pid, count, window]) do Kernel.send(self(), :bind) {:ok, %{waiting_pid: waiting_pid, count_to_send: count, count_waiting_resp: 0, window: window}} end def handle_resp(pdu, _original_pdu, st) do case SMPPEX.Pdu.command_name(pdu) do :submit_sm_resp -&gt; new_st = %{ st | count_waiting_resp: st.count_waiting_resp - 1 } send_pdus(new_st) :bind_transmitter_resp -&gt; send_pdus(st) _ -&gt; {:ok, st} end end def handle_resp_timeout(pdu, st) do Logger.error(&quot;PDU timeout: \#{inspect pdu}, terminating&quot;) {:stop, :resp_timeout, st} end def terminate(reason, _, st) do Logger.info(&quot;ESME stopped with reason \#{inspect reason}&quot;) Kernel.send(st.waiting_pid, {self(), :done}) :stop end def handle_info(:bind, st) do {:noreply, [SMPPEX.Pdu.Factory.bind_transmitter(@system_id, @password)], st} end defp send_pdus(st) do cond do st.count_to_send &gt; 0 -&gt; count_to_send = min(st.window - st.count_waiting_resp, st.count_to_send) new_st = %{ st | count_waiting_resp: st.window, count_to_send: st.count_to_send - count_to_send } {:ok, make_pdus(count_to_send), new_st} st.count_waiting_resp &gt; 0 -&gt; {:ok, st} true -&gt; Logger.info(&quot;All PDUs sent, all resps received, terminating&quot;) {:stop, :normal, st} end end defp make_pdus(0), do: [] defp make_pdus(n) do for _ &lt;- 1..n, do: SMPPEX.Pdu.Factory.submit_sm(@from, @to, @message) end endNot all callbacks are used yet in this example, for the full list see SMPPEX.Session documentation.","ref":"examples.html#smppex-esme","title":"SMPPEX - SMPPEX.ESME","type":"extras"},{"doc":"SMPPEX.MC is used for receiving and handling SMPP connections.Here is an example of a very simple MC, which does the following:Starts and listens to connections on the specified port.Responds with OK status to all incoming binds.Responds with incremental message ids to all incoming submit_sm packets (regardless of the bind state). defmodule MC do use SMPPEX.Session alias SMPPEX.Pdu alias SMPPEX.Pdu.Factory, as: PduFactory def start(port) do SMPPEX.MC.start({__MODULE__, []}, [transport_opts: [port: port]]) end def init(_socket, _transport, []) do {:ok, 0} end def handle_pdu(pdu, last_id) do case Pdu.command_name(pdu) do :submit_sm -&gt; {:ok, [PduFactory.submit_sm_resp(0, to_string(last_id)) |&gt; Pdu.as_reply_to(pdu)], last_id + 1} :bind_transmitter -&gt; {:ok, [PduFactory.bind_transmitter_resp(0) |&gt; Pdu.as_reply_to(pdu)], last_id} _ -&gt; {:ok, last_id} end end end","ref":"examples.html#smppex-mc","title":"SMPPEX - SMPPEX.MC","type":"extras"},{"doc":"Related projectsBesides the core SMPPEX project there are some auxilary projects.","ref":"projects.html","title":"Related projects","type":"extras"},{"doc":"smppsend is a simple CLI utility for testing SMSC connections. It allows to bind to SMSCs, send submit_sm PDUs and wait for delivery reports.","ref":"projects.html#smppsend","title":"Related projects - smppsend","type":"extras"},{"doc":"smppex_web is a simple demonstrational MC (SMPP server) with web interface.A public installation is available online at:Web: smppex.rubybox.ru.SMPP: smppex.rubybox.ru:2775It is useful for manual preliminary testing of SMPP clients.One can connect to the demonstrational MC with the mensioned smppssend tool:./smppsend --host smppex.rubybox.ru --port 2775 --system-id systemid --password pass --bind-mode trx --submit-sm --source-addr from123 --source-addr-npi 1 --source-addr-ton 5 --destination-addr 99999999999 --dest-addr-npi 1 --dest-addr-ton 1 --short-message HelloHelloHelloHelloHelloHelloHelloHelloHello --data-coding 8 --split-max-bytes 30 --udh-ref 123 --ucs2 --registered-delivery 1 --wait 19:57:33.677 [info] Connecting to smppex.rubybox.ru:2775 19:57:33.749 [info] Connected 19:57:33.753 [info] Binding pdu: bind_transceiver command_id: 9 command_status: 0 (ok) sequence_number: 0 mandatory fields: addr_npi: nil addr_ton: nil address_range: nil interface_version: nil password: &quot;pass&quot; system_id: &quot;systemid&quot; system_type: nil optional fields: [] ...","ref":"projects.html#smppex_web","title":"Related projects - smppex_web","type":"extras"},{"doc":"smpp_benchmarks is a bunch of benchmarks to run against SMPPEX.","ref":"projects.html#smpp_benchmarks","title":"Related projects - smpp_benchmarks","type":"extras"},{"doc":"smppex_telemetry is an advanced implementation of SMPPEX.Session which emits telemetry events.","ref":"projects.html#smppex_telemetry","title":"Related projects - smppex_telemetry","type":"extras"},{"doc":"Sometimes it is important to shutdown one or many SMPP sessions &quot;gracefully&quot;, i.e. to send unbind PDU and wait for a response before disconnect.smppex_graceful contains an example of how one can organize ESME sessions to achieve this.","ref":"projects.html#smppex_graceful","title":"Related projects - smppex_graceful","type":"extras"},{"doc":"ChangelogAll notable changes to this project will be documented in this file.The format is based on Keep a Changelog and this project adheres to Semantic Versioning.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - [Unreleased]","type":"extras"},{"doc":"AddedDocumentation of auxilary projects.ChangedOrganization of documents.","ref":"changelog.html#3-0-4-2021-04-17","title":"Changelog - [3.0.4] - 2021-04-17","type":"extras"},{"doc":"Addedsession_module option for MC and ESME modules to provide alternative implementations of SMPPEX.TransportSession behavior.","ref":"changelog.html#3-0-3-2021-04-16","title":"Changelog - [3.0.3] - 2021-04-16","type":"extras"},{"doc":"ChangedRemoved poison from dev dependencies.","ref":"changelog.html#3-0-2-2021-04-06","title":"Changelog - [3.0.2] - 2021-04-06","type":"extras"},{"doc":"ChangedRemoved poison from production dependencies.","ref":"changelog.html#3-0-1-2020-12-13","title":"Changelog - [3.0.1] - 2020-12-13","type":"extras"},{"doc":"ChangedFixed callback flow while accepting connections in MC. init callbacks are now run after socket transport handshake (as it always should have been).Updated Ranch to 2.0.Dropped OTP &lt; 21 support for Ranch 2.0 compatibility.Fixed source_subaddress TLV spec (Menkir).","ref":"changelog.html#3-0-0-2020-12-13","title":"Changelog - [3.0.0] - 2020-12-13","type":"extras"},{"doc":"ChangedFixed low level socket configuration in ESME (IceDragon200).Updated dev/test dependency versions.Dropped Elixir &lt; 1.7 support.","ref":"changelog.html#2-4-0-2020-11-05","title":"Changelog - [2.4.0] - 2020-11-05","type":"extras"},{"doc":"ChangedFixed submit_multi handling (Menkir).Moved repo to funbox organization.Set the esm_class field for a delivery report pdu created by factory.AddedTimeout argument to Session.send_pdu/2 function.","ref":"changelog.html#2-3-3-2020-09-09","title":"Changelog - [2.3.3] - 2020-09-09","type":"extras"},{"doc":"AddedOption to set arbitrary initial sequence number for SMPP sessions.","ref":"changelog.html#2-3-2-2019-11-19","title":"Changelog - [2.3.2] - 2019-11-19","type":"extras"},{"doc":"AddedElixir 1.9 builds in CI.Updated excoveralls dependency.Added SMPPEX.Pdu.ValidityPeriod module for dealing with validity_period PDU field.RemovedRemoved Elixir 1.2, 1.3 support and the corresponding builds from CI.","ref":"changelog.html#2-3-1-2019-09-19","title":"Changelog - [2.3.1] - 2019-09-19","type":"extras"},{"doc":"AddedElixir 1.8 builds in CI.RemovedOTP 18 support.ChangedFixed data_sm packet syntax.","ref":"changelog.html#2-3-0-2019-04-08","title":"Changelog - [2.3.0] - 2019-04-08","type":"extras"},{"doc":"ChangedUnfixed ranch from &lt; 1.6.0, since its internal changes do not affect our code.","ref":"changelog.html#2-2-9-2018-11-22","title":"Changelog - [2.2.9] - 2018-11-22","type":"extras"},{"doc":"ChangedFixed automatic enquire_link sequence id generation.Fixed ranch to &lt; 1.6.0 due to its incompatible changes.","ref":"changelog.html#2-2-8-2018-11-11","title":"Changelog - [2.2.8] - 2018-11-11","type":"extras"},{"doc":"AddedParsing mudule for network_error_code field.network_error_code field support in oserl converter.","ref":"changelog.html#2-2-7-2018-06-08","title":"Changelog - [2.2.7] - 2018-06-08","type":"extras"},{"doc":"AddedHandling of generic GenServer call and cast messages.ChangedFixed handling of PDUs with negative send_pdu_result status: they do not appear in handle_resp_timeout callack anymore.","ref":"changelog.html#2-2-6-2018-06-05","title":"Changelog - [2.2.6] - 2018-06-05","type":"extras"},{"doc":"Addedsubmit_sm factory methods with automatic TON/NPI detection.ChangedDropped Elixir 1.1.1 and OTP 17 support.Made SMPPEX.ESME.Sync be safe for making requestd from multiple processes.","ref":"changelog.html#2-2-5-2018-05-23","title":"Changelog - [2.2.5] - 2018-05-23","type":"extras"},{"doc":"ChangedUpdated build matrix for Travis CI. Removed assets for obsolete version builds.Updated build matrix for Travis CI. Added Elixir 1.6.Added explicit extract functions in SMPPEX.Pdu.Multipart.Fixed Ranch transport handling in SMPPEX.TransportSession, this fixes SSL transport support.","ref":"changelog.html#2-2-4-2018-02-12","title":"Changelog - [2.2.4] - 2018-02-12","type":"extras"},{"doc":"ChangedSMPPEX.ESME.Sync: ignore successful send_pdu_result for syncronously sent PDUs.SMPPEX.ESME.Sync: exit with normal on socket close.","ref":"changelog.html#2-2-3-2017-09-21","title":"Changelog - [2.2.3] - 2017-09-21","type":"extras"},{"doc":"ChangedFixed handling socket close/error for SMPPEX.ESME.Sync","ref":"changelog.html#2-2-2-2017-09-21","title":"Changelog - [2.2.2] - 2017-09-21","type":"extras"},{"doc":"ChangedLoosened ranch version requirements.","ref":"changelog.html#2-2-1-2017-09-11","title":"Changelog - [2.2.1] - 2017-09-11","type":"extras"},{"doc":"ChangedAdded strict response type for terminate callback. Also, terminate callback is now allowed to return some last pdus for sending.","ref":"changelog.html#2-2-0-2017-09-10","title":"Changelog - [2.2.0] - 2017-09-10","type":"extras"},{"doc":"AddedAutomatic handling of enquire_link and enquire_link_resp PDUs.","ref":"changelog.html#2-1-0-2017-09-10","title":"Changelog - [2.1.0] - 2017-09-10","type":"extras"},{"doc":"ChangedPduStorage implementation to be OTP 17 compatible.","ref":"changelog.html#2-0-1-2017-09-02","title":"Changelog - [2.0.1] - 2017-09-02","type":"extras"},{"doc":"This release contains significant architectural changes and API incompatibilities.ChangedAdded single SMPPEX.Session behavior instead of seperate SMPPEX.ESME and SMPPEX.MC behaviours.SMPPEX.Session callbacks are more GenServer compliant.Most of SMPPEX.Session callbacks are allowed to return stop indicating tuple.Most of SMPPEX.Session callbacks are allowed to return a list of PDUs to send.All methods interacting with SMPPEX.Session are synchronous.AddedElixir 1.5 builds in CI.RemovedUsage of a separate process for ESME/MC connections.Usage of ranch supervisor of launching ESME connections.Special methods for sending PDU replies to ESME/MC in favor of Pdu.as_reply_to/2 method.","ref":"changelog.html#2-0-0-2017-08-30","title":"Changelog - [2.0.0] - 2017-08-30","type":"extras"},{"doc":"Changedex_doc updated to 1.x.","ref":"changelog.html#1-0-1-2017-08-30","title":"Changelog - [1.0.1] - 2017-08-30","type":"extras"},{"doc":"This is the first stable release introduced from numerous 0.x.x versions. Although this library has been already used in production for quite a while, it's only purpose is to designate the divergence from 2.x.x branch.AddedESME functionality.MC functionality.Synchronous ESME client.","ref":"changelog.html#1-0-0-2017-08-30","title":"Changelog - [1.0.0] - 2017-08-30","type":"extras"},{"doc":"MIT License Copyright 2017 Ilya Averyanov Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]